#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{

    [Description("Enter the description of your new custom indicator here")]
    public class ATRDaily : Indicator
    {
        #region Variables
 
            private int period = 20; 
		    private double nATRs = 3; 
		
// Internas
		
		
    
        #endregion


        protected override void Initialize()
        {
            Add(new Plot(Color.FromKnownColor(KnownColor.Red), PlotStyle.Line, "Plot0"));
			Plots[0].Pen.Width=2;
            Overlay				= false;
			Add(PeriodType.Day,1);
			
        }


        protected override void OnBarUpdate()
        {
			
		if (CurrentBar < period*144)	return;
	
		Plot0.Set(ATR(BarsArray[1],period)[0]* NATRs);
			
        }

        #region Properties
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries Plot0
        {
            get { return Values[0]; }
        }

        [Description("")]
        [GridCategory("Parameters")]
        public int Period
        {
            get { return period; }
            set { period = Math.Max(1, value); }
        }
		
		   [Description("")]
        [Category("Parameters")]
        public double NATRs
        {
            get { return nATRs; }
            set { nATRs = Math.Max(0, value); }
        }
		
        #endregion
    }
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private ATRDaily[] cacheATRDaily = null;

        private static ATRDaily checkATRDaily = new ATRDaily();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public ATRDaily ATRDaily(double nATRs, int period)
        {
            return ATRDaily(Input, nATRs, period);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public ATRDaily ATRDaily(Data.IDataSeries input, double nATRs, int period)
        {
            if (cacheATRDaily != null)
                for (int idx = 0; idx < cacheATRDaily.Length; idx++)
                    if (Math.Abs(cacheATRDaily[idx].NATRs - nATRs) <= double.Epsilon && cacheATRDaily[idx].Period == period && cacheATRDaily[idx].EqualsInput(input))
                        return cacheATRDaily[idx];

            lock (checkATRDaily)
            {
                checkATRDaily.NATRs = nATRs;
                nATRs = checkATRDaily.NATRs;
                checkATRDaily.Period = period;
                period = checkATRDaily.Period;

                if (cacheATRDaily != null)
                    for (int idx = 0; idx < cacheATRDaily.Length; idx++)
                        if (Math.Abs(cacheATRDaily[idx].NATRs - nATRs) <= double.Epsilon && cacheATRDaily[idx].Period == period && cacheATRDaily[idx].EqualsInput(input))
                            return cacheATRDaily[idx];

                ATRDaily indicator = new ATRDaily();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.NATRs = nATRs;
                indicator.Period = period;
                Indicators.Add(indicator);
                indicator.SetUp();

                ATRDaily[] tmp = new ATRDaily[cacheATRDaily == null ? 1 : cacheATRDaily.Length + 1];
                if (cacheATRDaily != null)
                    cacheATRDaily.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheATRDaily = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ATRDaily ATRDaily(double nATRs, int period)
        {
            return _indicator.ATRDaily(Input, nATRs, period);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.ATRDaily ATRDaily(Data.IDataSeries input, double nATRs, int period)
        {
            return _indicator.ATRDaily(input, nATRs, period);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ATRDaily ATRDaily(double nATRs, int period)
        {
            return _indicator.ATRDaily(Input, nATRs, period);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.ATRDaily ATRDaily(Data.IDataSeries input, double nATRs, int period)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.ATRDaily(input, nATRs, period);
        }
    }
}
#endregion
