#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Indicator;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Strategy;
#endregion

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{

    [Description("")]
    public class VanTharpAleatorioV1 : Strategy
    {
        #region Variables

        private int aTRSesiones = 10;    
        private double aTR_Mult = 3; 
		private bool posSize=true;
		private double porcentaje=1;
		private double	cuentaInicial= 100000;
		
		// Internal
		
		Random ALT = new Random();
		
		private double Maximo = 0;
		private double Minimo= 0;
		
		private double TrailLong =0;
		private double TrailShort =0;
		
		private double Lots=0;
		private double ValorCuenta=0;
		private double RiesgoTrade=0;// Distancia entrada y SL en Moneda
		
		
        #endregion

 
        protected override void Initialize()
        {
			Add(PeriodType.Day, 1);
			Add(ATRDaily(aTR_Mult,aTRSesiones));
			ExitOnClose = false;
            CalculateOnBarClose = true;
			
        }

        protected override void OnBarUpdate()
        {	

				
			if( CurrentBar < aTRSesiones)return;
			if (BarsInProgress != 0) return;
	
			
			int Naleatorio = ALT.Next(1,100); 
			ValorCuenta=CuentaInicial+Performance.AllTrades.TradesPerformance.Currency.CumProfit;
			RiesgoTrade=(ATR(BarsArray[1],aTRSesiones)[0] * aTR_Mult)*Instrument.MasterInstrument.PointValue;
				
	
			if (Position.MarketPosition == MarketPosition.Flat)
			{
				Minimo= double.MaxValue;	
				Maximo = 0;			
				if( Naleatorio >= 50 )
				{		
					PositionSize();
					EnterLong((int)Lots, "");
					SetStopLoss(CalculationMode.Ticks, ATR(BarsArray[1],aTRSesiones)[0] * aTR_Mult);
					
				}	
			
				else if ( Naleatorio < 50 )
				{
					PositionSize();
					EnterShort((int)Lots, "");
					SetStopLoss(CalculationMode.Ticks, ATR(BarsArray[1],aTRSesiones)[0] * aTR_Mult);
				}
			}
			else if (Position.MarketPosition == MarketPosition.Long)
			{
				if ( High[0] > Maximo)
					{
						Maximo = High[0];
					}			
				TrailLong = Maximo - ATR(BarsArray[1],aTRSesiones)[0] * aTR_Mult;
				DrawDot(CurrentBar.ToString() + "SLL",true, 0, TrailLong, Color.Red);
				SetStopLoss(CalculationMode.Price, TrailLong);
				//ExitLongStop(TrailLong, "", "");
			}
			
			else if ( Position.MarketPosition == MarketPosition.Short)
			{
				if (Low[0] < Minimo)
				{
					Minimo = Low[0];
				}	
				TrailShort=Minimo+ATR(BarsArray[1],aTRSesiones)[0] * aTR_Mult;
				DrawDot(CurrentBar.ToString() + "SLS",true, 0, TrailShort, Color.Red);
				SetStopLoss(CalculationMode.Price, TrailShort);
				//ExitShortStop(TraiShort, "", "");	
			}

		}
	
	void PositionSize()
		{
			Lots=ValorCuenta*(porcentaje/100)/RiesgoTrade;
			
			if (Lots > 1 && posSize)
							Lots = Math.Round(Lots);
					else
							Lots = 1;
			PrintWithTimeStamp("ValorCuenta:  "+ValorCuenta);
			PrintWithTimeStamp("RiesgoTrade:  "+RiesgoTrade);
			PrintWithTimeStamp("Lots:  "+Lots);
			
		}


        #region Properties

        [Description("")]
        [Category("Parameters")]
        public int ATRSesiones
        {
            get { return aTRSesiones; }
            set { aTRSesiones = Math.Max(1, value); }
        }

        [Description("")]
        [Category("Parameters")]
        public double ATR_Mult
        {
            get { return aTR_Mult; }
            set { aTR_Mult = Math.Max(0, value); }
        }
		
	    [Description("")]
        [GridCategory("Parameters")]
        public bool PosSize
        {
            get { return posSize; }
            set { posSize = value; }
        }
		
        [Description("")]
        [Category("Parameters")]
        public double Porcentaje
        {
            get { return porcentaje; }
            set { porcentaje = Math.Max(0, value); }
        }

		        [Description("")]
        [Category("Parameters")]
        public double CuentaInicial
        {
            get { return cuentaInicial; }
            set { cuentaInicial = Math.Max(0, value); }
        }

        #endregion
    }

}

